/* tslint:disable */
/* eslint-disable */
/**
* Convert DFA to mermaid graph
* Throws when the JSON is invalid
* @param {string} dfa_json
* @returns {string}
*/
export function dfa2mermaid(dfa_json: string): string;
/**
* Convert NFA to mermaid graph
* Throws when the JSON is invalid
* @param {string} nfa_json
* @returns {string}
*/
export function nfa2mermaid(nfa_json: string): string;
/**
* Construct NFA from regular expression
* and return the JSON representation
* Throws when the regular expression is invalid
* We only support the following syntax:
* ```txt
* <regex> ::= <term> '|' <regex> | <term>
* <term> ::= <factor> <term> | <factor>
* <factor> ::= <base> '*' | <base>
* <base> ::= <char> | '(' <regex> ')'
* ```
* @param {string} reg
* @returns {string}
*/
export function reg2nfa(reg: string): string;
/**
* Convert NFA to DFA
* Returns (dfa_json, markdown)
* Throws when the NFA JSON is invalid
* @param {string} nfa_json
* @returns {(string)[]}
*/
export function nfa2dfa(nfa_json: string): (string)[];
/**
* Minimize DFA
* Returns (min_dfa_json, markdown)
* Throws when the DFA JSON is invalid
* @param {string} dfa_json
* @returns {(string)[]}
*/
export function minimize_dfa(dfa_json: string): (string)[];
/**
* Test if the input string is accepted by the DFA
* Returns true if accepted, false otherwise
* Throws when the DFA JSON is invalid
* @param {string} dfa_json
* @param {string} input
* @returns {boolean}
*/
export function test_dfa(dfa_json: string, input: string): boolean;
/**
* Test if the input string is accepted by the NFA
* Returns true if accepted, false otherwise
* Throws when the NFA JSON is invalid
* @param {string} nfa_json
* @param {string} input
* @returns {boolean}
*/
export function test_nfa(nfa_json: string, input: string): boolean;
